package smr.controlador;

import java.util.Map;
import java.util.Random;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import utils.componentes.Dades;
import utils.componentes.Resultado;

public abstract class AluUtils {
	
	public static final String load = "LOAD";
	public static final String store = "STORE";
	public static final String limmh = "LImmH";
	public static final String limml = "LImmL";
	
	public static final String add = "ADD";
	public static final String addi = "ADDI";
	public static final String sub = "SUB";
	public static final String subi = "SUBI";
	public static final String mul =  "MUL";
	public static final String muli =  "MULI";
	public static final String div = "DIV";
	public static final String divi = "DIVI";
	public static final String sqr = "SQR";
	public static final String sqrt = "SQRT";
	
	public static final String and = "AND";
	public static final String andi = "ANDI";
	public static final String or = "OR";
	public static final String ori = "ORI";
	public static final String xor ="XOR";
	public static final String xori ="XORI";
	public static final String not = "NOT";
	
	public static final String jump = "JUMP";
	public static final String beq = "BEQ";
	public static final String bneq = "BNEQ";
	public static final String bge = "BGE";
	public static final String bgoeq = "BGOEQ";
	public static final String ble = "BLE";
	
	public static final String noop = "NOOP";
	
	public static final String mov = "MOV";
	public static final String rtr = "RTR";
	public static final String rtl = "RTL";
	private static Exception ex;
	
	public static String intToString(int number, int groupSize) {
	    StringBuilder result = new StringBuilder();

	    for(int i = 31; i >= 0 ; i--) {
	        int mask = 1 << i;
	        result.append((number & mask) != 0 ? "1" : "0");

	        if (i % groupSize == 0)
	            result.append("");
	    }

	    return result.toString();
	}
	
	
	public static String intToString16(int number, int groupSize) {
	    StringBuilder result = new StringBuilder();

	    for(int i = 0; i <= 15 ; i++) {
	        int mask = 1 << i;
	        result.append((number & mask) != 0 ? "1" : "0");

	        if (i % groupSize == 0)
	            result.append("");
	    }
	    return result.toString();
	}
	
	public static Resultado execute(String codigoOperacion, String destino, String font1, String font2,String offset,Map<String,Integer> mapaRegistros,Map<String,Integer> mapaMemoria,Integer iteratorInstrucciones,Integer pcCounter) {
		
		Resultado resultado= new Resultado();
		switch(codigoOperacion){
			//memria
			case limmh:{
				try{
				String offsetValue;
				//pasamos el offset a 32 bits
				if(Integer.parseInt(offset)>=0){
					offsetValue = Integer.toBinaryString(Integer.parseInt(offset));
					offsetValue = intToString(Integer.parseInt(offsetValue, 2),1);
				}
				else{
					offsetValue = Integer.toBinaryString(Integer.parseInt(offset));
				}
				//cogemos por defecto el 0
				String offsetValueOld = intToString(0,1);
				if(mapaRegistros.get(destino)!=null){
					if(mapaRegistros.get(destino)>=0){
						offsetValueOld = Integer.toBinaryString(mapaRegistros.get(destino));
						offsetValueOld = intToString(Integer.parseInt(offsetValueOld, 2),1);
					}
					else{
						offsetValueOld = Integer.toBinaryString(mapaRegistros.get(destino));
					}
				}
				String result = "";
				for(int i=0;i<16;i++){
					if(offsetValue.charAt(i)=='1' && i<16){
						result = result + '1';
						}
					else{
						result = result + '0';
						}
				}
				//termino llenar el result a 32 bits con los bits del registro destino.
				for(int i=16;i<32;i++){
					result = result + offsetValueOld.charAt(i);
				}
				Integer resDestino = bitsTointeger(result);
				mapaRegistros.put(destino,resDestino);
				resultado.setLlave(destino);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			
			case limml:{
				try{
				String offsetValue;
				//pasamos el offset a 32 bits
				if(Integer.parseInt(offset)>=0){
					offsetValue = Integer.toBinaryString(Integer.parseInt(offset));
					offsetValue = intToString(Integer.parseInt(offsetValue, 2),1);
				}
				else{
					offsetValue = Integer.toBinaryString(Integer.parseInt(offset));
				}
				//cogemos por defecto el 0
				String offsetValueOld = intToString(0,1);
				if(mapaRegistros.get(destino)!=null){
					if(mapaRegistros.get(destino)>=0){
						offsetValueOld = Integer.toBinaryString(mapaRegistros.get(destino));
						offsetValueOld = intToString(Integer.parseInt(offsetValueOld, 2),1);
					}
					else{
						offsetValueOld = Integer.toBinaryString(mapaRegistros.get(destino));
					}
				}
				String result = "";
				for(int i=16;i<32;i++){
					if(offsetValue.charAt(i)=='1' && i>15){
						result = result + '1';
						}
					else{
						result = result + '0';
						}
				}
				//termino llenar el result a 32 bits con los bits del registro destino.
				result = intToString(Integer.parseInt(result, 2),1);
				//convertimos el resultado en entero y lo guardamos en el valor del registro destino
				Integer resDestino = bitsTointeger(result);
				mapaRegistros.put(destino,resDestino);
				resultado.setLlave(destino);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			
			case load:{
				try{
				Integer offsetValue= Integer.parseInt(offset);
				Integer registroValue = mapaRegistros.get(font2);
//				Integer valorResultado = offsetValue+registroValue;
				Integer direccionMemoria = offsetValue+registroValue;
				Integer valorResultado = mapaMemoria.get(""+(direccionMemoria));
				if(valorResultado==null){
					JOptionPane.showMessageDialog(new JFrame(),"Memoria : @ "+ direccionMemoria +" no existe.", "Dialog",JOptionPane.ERROR_MESSAGE);
					System.exit(0);
				}
				mapaRegistros.put(destino,valorResultado);
				resultado.setLlave(destino);
				resultado.setValor(""+valorResultado);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			case store:{
				//parametros de entrada=font1,font2,Offset
				//Accion Mem(CR[Font2]+Offset)<--CR[font1]
				try{
				Integer offsetValue = Integer.parseInt(offset);
				Integer font2Value=mapaRegistros.get(font2);
				//Integer valorResultado = mapaMemoria.get(font2Value+offsetValue);
				Integer font1Value = mapaRegistros.get(font1);
				mapaMemoria.put(""+(font2Value+offsetValue),font1Value);
				destino=""+(font2Value+offsetValue);
				resultado.setLlave("M"+destino);
				resultado.setValor(""+font1Value);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			//aritmticas
			case add :{
				//suma de 2 registros desti,font1,font2
				try{
				resultado.setLlave(destino);
				Integer res = mapaRegistros.get(font1)+mapaRegistros.get(font2);
				resultado.setValor(""+res);
				mapaRegistros.put(destino,res);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(ArithmeticException ex){
					captura_exeption(ex);
				}
				break;
			}
			case addi:{
				//suma de 2 registros desti,font1,offset
				try{
				Integer offsetValue = Integer.parseInt(offset);
				resultado.setLlave(destino);
				Integer res = mapaRegistros.get(font1)+offsetValue;
				resultado.setValor(""+res);
				mapaRegistros.put(destino,res);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(ArithmeticException ex){
					captura_exeption(ex);
				}
				break;
			}
			case sub :{
				//resta lo que hay en en font1 - font2 y lo guarda en destino 
				try{
				resultado.setLlave(destino);
				Integer res = mapaRegistros.get(font1)-mapaRegistros.get(font2);
				resultado.setValor(""+res);
				mapaRegistros.put(destino,res);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(ArithmeticException ex){
					captura_exeption(ex);
				}
				break;
			}
			case subi :{
				try{
				Integer offsetValue = Integer.parseInt(offset);
				resultado.setLlave(destino);
				Integer res = mapaRegistros.get(font1)-offsetValue;
				resultado.setValor(""+res);
				mapaRegistros.put(destino,res);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(ArithmeticException ex){
					captura_exeption(ex);
				}
				break;
			}
			case mul :{
				try{
				resultado.setLlave(destino);
				Integer res = mapaRegistros.get(font1)*mapaRegistros.get(font2);
				resultado.setValor(""+res);
				mapaRegistros.put(destino,res);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(ArithmeticException ex){
					captura_exeption(ex);
				}
				break;
			}
			case muli :{
				try{
				Integer offsetValue = Integer.parseInt(offset);
				resultado.setLlave(destino);
				Integer res = mapaRegistros.get(font1)*offsetValue;
				resultado.setValor(""+res);
				mapaRegistros.put(destino,res);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(ArithmeticException ex){
					captura_exeption(ex);
				}
				break;
			}
			case div :{
				//div
				try{
				resultado.setLlave(destino);
				Integer res = (Integer)(mapaRegistros.get(font1)/mapaRegistros.get(font2));
				resultado.setValor(""+res);
				mapaRegistros.put(destino,res);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(ArithmeticException ex){
					captura_exeption(ex);
				}
				break;
			}
			case divi :{
				try{
				Integer offsetValue = Integer.parseInt(offset);
				resultado.setLlave(destino);
				Integer res = (Integer)(mapaRegistros.get(font1)/offsetValue);
				resultado.setValor(""+res);
				mapaRegistros.put(destino,res);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(ArithmeticException ex){
					captura_exeption(ex);
				}
				break;
			}
			case sqrt:{
				resultado.setLlave(destino);
				Double resd = (double)mapaRegistros.get(font1);
				if(resd<0){
					JOptionPane.showMessageDialog(new JFrame(),"Operacion: "+ sqrt +" no es posible para numeros < 0", "Dialog",JOptionPane.ERROR_MESSAGE);
					System.exit(0);
				}
				Integer res = (int) Math.sqrt(resd);
				resultado.setValor(""+res);
				mapaRegistros.put(destino,res);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				break;
			}
			case sqr :{
				//desti,font1
				try{
				resultado.setLlave(destino);
				Double resd = (double)mapaRegistros.get(font1);
				Integer res = (int) (resd*resd);
				mapaRegistros.put(destino,res);
				resultado.setValor(""+res);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(ArithmeticException ex){
					captura_exeption(ex);
				}
				break;
			}
			//logicas
			case and :{
				try{
				String font1Value;
				String font2Value;
				if(mapaRegistros.get(font1)>=0){
					String font1Valuebinario = Integer.toBinaryString(mapaRegistros.get(font1));
					font1Value = intToString(Integer.parseInt(font1Valuebinario, 2),1);
				}
				else{
					font1Value = Integer.toBinaryString(Integer.parseInt(font1));
				}
				if(mapaRegistros.get(font2)>=0){
					String font2Valuebinario = Integer.toBinaryString(mapaRegistros.get(font2));
					font2Value = intToString(Integer.parseInt(font2Valuebinario, 2),1);
				}
				else{
					font2Value = Integer.toBinaryString(Integer.parseInt(font2));
				}
				String result = "";
				for(int i=0;i<32;i++){
					if(font1Value.charAt(i)=='1' && font1Value.charAt(i)==font2Value.charAt(i)){
						result = result + '1';
						}
					else{
						result = result + '0';
						}
				}
				Integer resDestino = bitsTointeger(result);
				mapaRegistros.put(destino,resDestino);
				resultado.setLlave(destino);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			case andi :{
				try{
				String font1Value;
				String font2Value;
				if(mapaRegistros.get(font1)>=0){
					String font1Valuebinario = Integer.toBinaryString(mapaRegistros.get(font1));
					font1Value = intToString(Integer.parseInt(font1Valuebinario, 2),1);
				}
				else{
					font1Value = Integer.toBinaryString(Integer.parseInt(font1));
				}
				if(Integer.parseInt(offset)>=0){
					String font2Valuebinario = Integer.toBinaryString(Integer.parseInt(offset));
					font2Value = intToString(Integer.parseInt(font2Valuebinario, 2),1);
				}
				else{
					font2Value = Integer.toBinaryString(Integer.parseInt(font2));
				}
				String result = "";
				for(int i=0;i<32;i++){
					if(font1Value.charAt(i)=='1' && font1Value.charAt(i)==font2Value.charAt(i)){
						result = result + '1';
						}
					else{
						result = result + '0';
						}
				}
				Integer resDestino = bitsTointeger(result);
				mapaRegistros.put(destino,resDestino);
				resultado.setLlave(destino);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			case or :{
				try{
				String font1Value;
				String font2Value;
				if(mapaRegistros.get(font1)>=0){
					String font1Valuebinario = Integer.toBinaryString(mapaRegistros.get(font1));
					font1Value = intToString(Integer.parseInt(font1Valuebinario, 2),1);
				}
				else{
					font1Value = Integer.toBinaryString(Integer.parseInt(font1));
				}
				if(mapaRegistros.get(font2)>=0){
					String font2Valuebinario = Integer.toBinaryString(mapaRegistros.get(font2));
					font2Value = intToString(Integer.parseInt(font2Valuebinario, 2),1);
				}
				else{
					font2Value = Integer.toBinaryString(Integer.parseInt(font2));
				}
				String result = "";
				for(int i=0;i<32;i++){
					if(font1Value.charAt(i)=='0' && font2Value.charAt(i)=='1'){
						result = result + '1';
						}
					else if(font1Value.charAt(i)=='1' && font2Value.charAt(i)=='0'){
						result = result + '1';
					}
					else if(font1Value.charAt(i)=='1' && font2Value.charAt(i)=='1'){
						result = result + '1';
					}
					else{
						result = result + '0';
					}
				}
				Integer resDestino = bitsTointeger(result);
				mapaRegistros.put(destino,resDestino);
				resultado.setLlave(destino);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			case ori :{
				try{
				String font1Value;
				String font2Value;
				if(mapaRegistros.get(font1)>=0){
					String font1Valuebinario = Integer.toBinaryString(mapaRegistros.get(font1));
					font1Value = intToString(Integer.parseInt(font1Valuebinario, 2),1);
				}
				else{
					font1Value = Integer.toBinaryString(Integer.parseInt(font1));
				}
				if(Integer.parseInt(offset)>=0){
					String font2Valuebinario = Integer.toBinaryString(Integer.parseInt(offset));
					font2Value = intToString(Integer.parseInt(font2Valuebinario, 2),1);
				}
				else{
					font2Value = Integer.toBinaryString(Integer.parseInt(font2));
				}
				String result = "";
				for(int i=0;i<32;i++){
					if(font1Value.charAt(i)=='0' && font2Value.charAt(i)=='1'){
						result = result + '1';
						}
					else if(font1Value.charAt(i)=='1' && font2Value.charAt(i)=='0'){
						result = result + '1';
					}
					else if(font1Value.charAt(i)=='1' && font2Value.charAt(i)=='1'){
						result = result + '1';
					}
					else{
						result = result + '0';
					}
				}
				Integer resDestino = bitsTointeger(result);
				mapaRegistros.put(destino,resDestino);
				resultado.setLlave(destino);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			
			case xor :{
				try{
				String font1Value;
				String font2Value;
				if(mapaRegistros.get(font1)>=0){
					String font1Valuebinario = Integer.toBinaryString(mapaRegistros.get(font1));
					font1Value = intToString(Integer.parseInt(font1Valuebinario, 2),1);
				}
				else{
					font1Value = Integer.toBinaryString(Integer.parseInt(font1));
				}
				if(mapaRegistros.get(font2)>=0){
					String font2Valuebinario = Integer.toBinaryString(mapaRegistros.get(font2));
					font2Value = intToString(Integer.parseInt(font2Valuebinario, 2),1);
				}
				else{
					font2Value = Integer.toBinaryString(Integer.parseInt(font2));
				}
				String result = "";
				for(int i=0;i<32;i++){
					if(font1Value.charAt(i)=='0' && font2Value.charAt(i)=='1'){
						result = result + '1';
						}
					else if(font1Value.charAt(i)=='1' && font2Value.charAt(i)=='0'){
						result = result + '1';
					}
					else if(font1Value.charAt(i)=='1' && font2Value.charAt(i)=='1'){
						result = result + '0';
					}
					else{
						result = result + '0';
					}
				}
				Integer resDestino = bitsTointeger(result);
				mapaRegistros.put(destino,resDestino);
				resultado.setLlave(destino);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			case xori :{
				try{
				String font1Value;
				String font2Value;
				if(mapaRegistros.get(font1)>=0){
					String font1Valuebinario = Integer.toBinaryString(mapaRegistros.get(font1));
					font1Value = intToString(Integer.parseInt(font1Valuebinario, 2),1);
				}
				else{
					font1Value = Integer.toBinaryString(Integer.parseInt(font1));
				}
				if(Integer.parseInt(offset)>=0){
					String font2Valuebinario = Integer.toBinaryString(Integer.parseInt(offset));
					font2Value = intToString(Integer.parseInt(font2Valuebinario, 2),1);
				}
				else{
					font2Value = Integer.toBinaryString(Integer.parseInt(font2));
				}
				String result = "";
				for(int i=0;i<32;i++){
					if(font1Value.charAt(i)=='0' && font2Value.charAt(i)=='1'){
						result = result + '1';
						}
					else if(font1Value.charAt(i)=='1' && font2Value.charAt(i)=='0'){
						result = result + '1';
					}
					else if(font1Value.charAt(i)=='1' && font2Value.charAt(i)=='1'){
						result = result + '0';
					}
					else{
						result = result + '0';
					}
				}
				Integer resDestino = bitsTointeger(result);
				mapaRegistros.put(destino,resDestino);
				resultado.setLlave(destino);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			
			case not :{
				try{
				String font1Value;
				if(mapaRegistros.get(font1)>=0){
					String font1Valuebinario = Integer.toBinaryString(mapaRegistros.get(font1));
					font1Value = intToString(Integer.parseInt(font1Valuebinario, 2),1);
				}
				else{
					font1Value = Integer.toBinaryString(Integer.parseInt(font1));
				}
				String result = "";
				for(int i=0;i<32;i++){
					if(font1Value.charAt(i)=='0'){
						result = result + '1';
						}
					else{
						result = result + '0';
					}
				}
				Integer resDestino=0;
				resDestino = bitsTointeger(result);
				mapaRegistros.put(destino,resDestino);
				resultado.setLlave(destino);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			//movimiento
			case mov :{
				//mov desti,font1
				//deplaza el contenido de  font1 a desti(del conjunto de registros)
				//no lo tengo claro que es lo que hace
				try{
				Integer font1Value = mapaRegistros.get(font1);
				mapaRegistros.put(destino, font1Value);
				resultado.setLlave(destino);
				resultado.setValor(""+font1Value);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			case rtr :{
				try{
				Integer offsetValue = Integer.parseInt(offset);
				Integer font1Value = mapaRegistros.get(font1);
				offsetValue=(int) Math.pow(2,offsetValue);
				Integer resDestino = Math.round(font1Value/offsetValue);
				//pasamos el valor a entero para mostrarlo se se quiere pasar a bit usamos la funcion antes declarada
				mapaRegistros.put(font1,resDestino);
				resultado.setLlave(font1);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
			case rtl :{
				try{
				Integer offsetValue = Integer.parseInt(offset);
				Integer font1Value = mapaRegistros.get(font1);
				offsetValue=(int) Math.pow(2,offsetValue);
				Integer resDestino = font1Value*offsetValue;
				//pasamos el valor a entero para mostrarlo se se quiere pasar a bit usamos la funcion antes declarada
				mapaRegistros.put(offset,resDestino);
				resultado.setLlave(font1);
				resultado.setValor(""+resDestino);
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				}
				catch(Exception ex){
					captura_ex(ex);
				}
				break;
			}
//			//control
			//IA
			case jump:{
				//jump offset
				//PC<-offset, pasarselo a PC , esto quiere decir que al ejecutarse la siguiente instruccion sera la que este apuntando el pc esta instruccion 
				//la instruccion a seguir sera la que estamos pasando como valor....
				Integer offsetValue = Integer.parseInt(offset)-1;
				
				resultado.setLlave("");
				resultado.setValor("");
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones+offsetValue);
				resultado.setPc(pcCounter+offsetValue);
				
				break;
			}
			case beq:{
				//si font1 = font2 PC <- offset
				Integer font1Value = mapaRegistros.get(font1);
				Integer font2Value = mapaRegistros.get(font2);
				Integer offsetValue = Integer.parseInt(offset)-1;
				if(font1Value==font2Value){
					resultado.setIteratorInstrucciones(iteratorInstrucciones+offsetValue);
					resultado.setPc(pcCounter+offsetValue);
				}else{
					resultado.setIteratorInstrucciones(iteratorInstrucciones+1);
					resultado.setPc(pcCounter+offsetValue+1);
				}
				resultado.setLlave("");
				resultado.setValor("");
				break;
			}
			case bneq:{
				//si font1 != font2 PC <- offset
				Integer font1Value = mapaRegistros.get(font1);
				Integer font2Value = mapaRegistros.get(font2);
				Integer offsetValue = Integer.parseInt(offset)-1;
				if(font1Value!=font2Value){
					resultado.setIteratorInstrucciones(iteratorInstrucciones+offsetValue);
					resultado.setPc(pcCounter+offsetValue);
				}else{
					resultado.setIteratorInstrucciones(iteratorInstrucciones+1);
					resultado.setPc(pcCounter+offsetValue+1);
				}
				//sino pc <- pc+1
				resultado.setLlave("");
				resultado.setValor("");
				
				break;
			}
			case bge:{
				//si font1 > font2 PC <- offset
				Integer font1Value = mapaRegistros.get(font1);
				Integer font2Value = mapaRegistros.get(font2);
				Integer offsetValue = Integer.parseInt(offset)-1;
				if(font1Value>font2Value){
					resultado.setIteratorInstrucciones(iteratorInstrucciones+offsetValue);
					resultado.setPc(pcCounter+offsetValue);
				}else{
					resultado.setIteratorInstrucciones(iteratorInstrucciones+1);
					resultado.setPc(pcCounter+offsetValue+1);
				}
				//sino pc <- pc+1
				resultado.setLlave("");
				resultado.setValor("");
				break;
			}
			case bgoeq:{
				//beq font1,font2,Offset
				//si font1 >= font2 PC <- offset
				Integer font1Value = mapaRegistros.get(font1);
				Integer font2Value = mapaRegistros.get(font2);
				Integer offsetValue = Integer.parseInt(offset)-3;
				if(font1Value>=font2Value){
					resultado.setIteratorInstrucciones(iteratorInstrucciones+offsetValue);
					resultado.setPc(pcCounter+offsetValue);
				}else{
					resultado.setIteratorInstrucciones(iteratorInstrucciones+1);
					resultado.setPc(pcCounter+1);
				}
				//sino pc <- pc+1
				resultado.setLlave("");
				resultado.setValor("");
				break;
			}
			case ble:{
				//si font1 >= font2 PC <- offset
				Integer font1Value = mapaRegistros.get(font1);
				Integer font2Value = mapaRegistros.get(font2);
				Integer offsetValue = Integer.parseInt(offset)-1;
				if(font1Value<font2Value){
					resultado.setIteratorInstrucciones(iteratorInstrucciones+offsetValue);
					resultado.setPc(pcCounter+offsetValue);
				}else{
					resultado.setIteratorInstrucciones(iteratorInstrucciones+1);
					resultado.setPc(pcCounter+offsetValue+1);
				}
				//sino pc <- pc+1
				resultado.setLlave("");
				resultado.setValor("");
				break;
			}
			
			//miscelnea
			case noop :{
				//no deberia de hacer nada es decir no devuelve retornara un resultado vacio
				resultado.setLlave("");
				resultado.setValor("");
				resultado.setMapaMemoria(mapaMemoria);
				resultado.setMapaRegistres(mapaRegistros);
				resultado.setIteratorInstrucciones(iteratorInstrucciones);
				resultado.setPc(pcCounter);
				break;
			}
			
			default:{
				
			}
		
		}
		return resultado;
	}

	private static void captura_ex(Exception ex) {
		JOptionPane.showMessageDialog(new JFrame(),""+ex.getMessage(), "Dialog",JOptionPane.ERROR_MESSAGE);
//		System.exit(0);
		
	}


	private static void captura_exeption(ArithmeticException ex) {
		JOptionPane.showMessageDialog(new JFrame(),""+ex.getMessage(), "Dialog",JOptionPane.ERROR_MESSAGE);
//		System.exit(0);
	}


	private static Integer bitsTointeger(String result) {
		Integer resultado=0;
		String resultadoString = "";
		if(result.startsWith("1")){
			//pasamos el todos los bits a positivos
			for(int i=0;i<32;i++){
				if(result.charAt(i)=='1'){
					resultadoString = resultadoString + '0';
					}
				else{
					resultadoString = resultadoString + '1';
				}
			}
			resultado = (Integer.parseInt(resultadoString,2)+1)*-1;
		}
		else{
			resultado = Integer.parseInt(result,2);
		}
		
		return resultado;
	}

}
