package smr.controlador;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Polygon;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import smr.vista.View;
import utils.componentes.AluPcCounter;
import utils.componentes.AluPrincipal;
import utils.componentes.Boton;
import utils.componentes.Bus;
import utils.componentes.Componente;
import utils.componentes.Dades;
import utils.componentes.Instruccion;
import utils.componentes.MultReg;
import utils.componentes.Registre;
import utils.componentes.Resultado;
/**

 * 
 * @author richard
 */
public class UcController extends Canvas{
    
        private AluPcCounter aluPcCounter;
        private AluPrincipal aluPrincipal;
        private MultReg multReg;
        private HashMap<String,Boton> botones = null;
        private HashMap<String,Bus> buses = null;        
        private HashMap<String,Componente> componentes = null;
        private HashMap<String,Polygon> otrosComp = null;
        //ucCnt esta instancia de la propia clase solo se usa en el thread
        //private UcController ucCnt = null;
        public HashMap<String,Registre> registres = null;
        private String opCode = "";
        public ArrayList<Instruccion> instruccionesSimulador=new ArrayList<Instruccion>(60);
        public CargadorInstrucciones cargadorInstrucciones=null;
        public CargadorMemoria cargadorMemoria=null;
        
        private ArrayList<Dades> dadesMemoria=new ArrayList<Dades>(); 
        //mouseEvent gestiona los eventos del raton
        private final GestorRaton mouseEv;
        private CargadorMemoria miVentana=null;
        private int pcCounter =0;
        private Resultado resultado = new Resultado();
        
        private Map<String,Integer> mapaDades = new HashMap<String,Integer>();
        private int totalInstrucciones = 0;
        private int iteratorInstrucciones = 0;
        private Map<String,Integer> mapaRegistres = new HashMap<String,Integer>();
        private Map<String,Integer> mapaMemoria = new HashMap<String,Integer>();
        
        private String txtinstruccionbuffer="";
        
        private boolean finalizado = false;
        public final static int menor = -2147483648;
        public final static int mayor = 2147483647;

   public class CargadorMemoria extends JFrame implements ItemListener{
       private JPanel jpMemoria = null;
       private JButton btnAddMemoria = new JButton("add");
       private BtnAddListenerMemoria btnAddListenerMemoria = new BtnAddListenerMemoria();
       private String[] registrosMemoria = {"0","1","2","3","4","5","6","7","8",
                                            "9","10","11","12","13","14","15",""};
       private JComboBox cbregistrosMemoria = new JComboBox(registrosMemoria);
       private JTextField tfoffset;
        private String keyMemSeleccionada;
       //  String keyMemSeleccionada=null;
       private String valueMemSeleccionada;
       
       public CargadorMemoria() {
           
           setBackground(Color.white);
           setBounds(1050,5,280,180);
           setTitle("LOAD DADES");
           this.getContentPane().setLayout(new GridBagLayout());
           
           JLabel registroOffset = new JLabel("Set @:");        
            GridBagConstraints constraints = new GridBagConstraints();
            constraints.gridx = 0;
            constraints.gridy = 0;
            constraints.gridwidth = 1;
            constraints.gridheight = 1;       
            constraints.fill=GridBagConstraints.HORIZONTAL;       
            this.getContentPane().add(registroOffset,constraints);       
            //combobox op de registro
            constraints.gridx = 1;
            constraints.gridy = 0;
            constraints.gridwidth = 1;
            constraints.gridheight = 1;
            constraints.fill=GridBagConstraints.HORIZONTAL;
            this.getContentPane().add(cbregistrosMemoria,constraints);
            cbregistrosMemoria.setSelectedIndex(9);
            cbregistrosMemoria.addItemListener(this);  
            
            tfoffset= new JTextField("               ");            
            tfoffset.setHorizontalAlignment(JTextField.LEFT);
            constraints.gridx = 2;
            constraints.gridy = 0;
            constraints.gridwidth = 1;
            constraints.gridheight = 1;
            constraints.fill = GridBagConstraints.HORIZONTAL;        
            this.getContentPane().add(tfoffset,constraints);

            constraints.gridx = 3;
            constraints.gridy = 1;
            constraints.gridwidth = 1;
            constraints.gridheight = 1;
            constraints.fill=GridBagConstraints.HORIZONTAL;  
            btnAddMemoria.addActionListener(btnAddListenerMemoria);
            this.getContentPane().add(btnAddMemoria,constraints);
          
            
            setVisible(true);
                
        }
       
    private class BtnAddListenerMemoria implements ActionListener{
        
       
        public BtnAddListenerMemoria() {
        }

        @Override
        public void actionPerformed(ActionEvent e) {
            if(e.getSource()==btnAddMemoria){
                Dades dade = new Dades();
               //
               boolean valorCorrecto;
               valueMemSeleccionada=tfoffset.getText().replace(" ","");
               try{
               valorCorrecto=validaValueMemSeleccionada(valueMemSeleccionada);
               //
               if(valorCorrecto){
	               keyMemSeleccionada=(String)cbregistrosMemoria.getSelectedItem();
	               System.out.println("llaveee"+keyMemSeleccionada);
	               //valueMemSeleccionada.replace(" ","");
	               dade.setDireccion(keyMemSeleccionada);              
	               dade.setValor(valueMemSeleccionada);               
	               mapaDades.put(keyMemSeleccionada, Integer.parseInt(valueMemSeleccionada));
	               dadesMemoria.add(dade);
	               tfoffset.setText("");//vacia el campo
               }else{
            	   JOptionPane.showMessageDialog(new JFrame(), "El numero introducido no es valido", "Dialog",JOptionPane.ERROR_MESSAGE);
   					return;
               }
               }
               catch(Exception ex){
            	   JOptionPane.showMessageDialog(new JFrame(), "El numero introducido no es valido", "Dialog",JOptionPane.ERROR_MESSAGE);
  					return;
               }
            }
        }
		
    }

        @Override
        public void itemStateChanged(ItemEvent e) {
              if (e.getSource()==cbregistrosMemoria ){
                    keyMemSeleccionada=(String)cbregistrosMemoria.getSelectedItem();                                      
            }
    }
    
   }
    
    public class CargadorInstrucciones extends JFrame implements ItemListener{
        
        private JPanel jpInstrucciones = null;
        private JButton btnOpen = new JButton(" Open ");
        private JButton btnAdd = new JButton(" ADD ");
        private JButton btnSave = new JButton(" Save ");
        private BtnSaveListener btnSaveListener = new BtnSaveListener();
        private BtnOpenListener btnOpenListener = new BtnOpenListener();
//        private JButton btnAddMemoria = new JButton(" ADD");
        private BtnAddListener btnAddListener = new BtnAddListener();
        
        private String[] registroOpAritmeticas = {"ADD","SUB","MUL","DIV","SQRT","ADDI","SUBI","MULI","DIVI","SQR",""};
        public String opSeleccionada = "";
        private JComboBox registroOpsAritmeticas = new JComboBox(registroOpAritmeticas);        
        private String[] logicasOp = {"AND","OR","XOR","NOT","ANDI","ORI","XORI",""};
        private JComboBox logicasOps = new JComboBox(logicasOp);
        private String[] controlOp = {"JUMP","BEQ","BNEQ","BGE","BGOEQ","BLE",""};
        private JComboBox controlOps = new JComboBox(controlOp);
        private String[] registromovimientoDesplazamiento = {"MOV","RTR","RTL",""};
        private JComboBox movimientoDesplazamiento = new JComboBox(registromovimientoDesplazamiento);
        private String[] registroMemoria = {"LImmH","LImmL","LOAD","STORE",""};
        private JComboBox registroMemoriaOps = new JComboBox(registroMemoria);
        private String[] registroMiscelanea = {"NOOP",""};
        private JComboBox registroMiscelaneaOps = new JComboBox(registroMiscelanea);
        
        //private Map<String,String> instrucciones = null;
        private String[] resgistrosFont1 = {"R1","R2","R3","R4","R5","R6","R7","R8",""};
         private JComboBox cbregistrosDesti = new JComboBox(resgistrosFont1);
         private String[] resgistrosFont2 = {"R1","R2","R3","R4","R5","R6","R7","R8",""};
         private JComboBox cbregistrosFont1 = new JComboBox(resgistrosFont2);
        private String[] resgistrosFont3 = {"R1","R2","R3","R4","R5","R6","R7","R8",""};
         private JComboBox cbregistrosFont2 = new JComboBox(resgistrosFont3);
         //
//         private String[] registrosMemoria = {"0","1","2","3","4","5","6","7","8",
//                                            "9","10","11","12","13","14","15",""};
//        private JComboBox cbregistrosMemoria = new JComboBox(registrosMemoria);
        private JTextField offsetInstruccion=null;
        
        private JTextArea areaTexto = null;
        
//        private String txtinstruccionbuffer="";
        
        TextField txtfieldoffset=new TextField();
        
    public CargadorInstrucciones(){
        
        setBackground(Color.white);
        //antes y=150
        setMinimumSize(new Dimension(320,550));
        setBounds(1050,10,280,550);
        setTitle("LOAD INSTRUCTION");
        this.getContentPane().setLayout(new GridBagLayout());
        
        JLabel logicas = new JLabel("Reg Lgicas:");
        GridBagConstraints constraints = new GridBagConstraints();
        constraints.gridx = 0;
        constraints.gridy = 0;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill = GridBagConstraints.NORTH;        
        this.getContentPane().add(logicas,constraints);
        
        constraints.gridx = 1;
        constraints.gridy = 0;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill=GridBagConstraints.HORIZONTAL;       
        this.getContentPane().add(logicasOps,constraints);
        logicasOps.setSelectedIndex(7);
        logicasOps.addItemListener(this);
                
        JLabel registro = new JLabel("Reg Aritmticas:");        
        
        constraints.gridx = 0;
        constraints.gridy = 1;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;       
        constraints.fill=GridBagConstraints.HORIZONTAL;       
        this.getContentPane().add(registro,constraints);       
        //combobox op de registro
        constraints.gridx = 1;
        constraints.gridy = 1;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill=GridBagConstraints.HORIZONTAL;
        this.getContentPane().add(registroOpsAritmeticas,constraints);
        registroOpsAritmeticas.setSelectedIndex(10);
        registroOpsAritmeticas.addItemListener(this);
        
        //registros de movimiento
        JLabel movimiento = new JLabel("Reg Movimiento:");
        constraints.gridx = 0;
        constraints.gridy = 2;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill = GridBagConstraints.NORTH;        
        this.getContentPane().add(movimiento,constraints);
        
        constraints.gridx = 1;
        constraints.gridy = 2;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill=GridBagConstraints.HORIZONTAL;       
        this.getContentPane().add(movimientoDesplazamiento,constraints);
        movimientoDesplazamiento.setSelectedIndex(3);
        movimientoDesplazamiento.addItemListener(this);        

        JLabel memoria = new JLabel(" Memria:");        
        constraints.gridx = 2;
        constraints.gridy = 0;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;       
        constraints.fill=GridBagConstraints.HORIZONTAL;       
        this.getContentPane().add(memoria,constraints);
        //combobox op de memoria
        constraints.gridx = 3;
        constraints.gridy = 0;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill=GridBagConstraints.HORIZONTAL;
        this.getContentPane().add(registroMemoriaOps,constraints);
        registroMemoriaOps.setSelectedIndex(4);
        registroMemoriaOps.addItemListener(this);   
        
        JLabel control = new JLabel(" Control:");
        constraints.gridx = 2;
        constraints.gridy = 1;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill=GridBagConstraints.HORIZONTAL; 
        this.getContentPane().add(control,constraints);
        
        constraints.gridx = 3;
        constraints.gridy = 1;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill=GridBagConstraints.HORIZONTAL;        
        this.getContentPane().add(controlOps,constraints);
        controlOps.setSelectedIndex(6);
        controlOps.addItemListener(this);
        
        JLabel miscelania = new JLabel(" Miscelnia:");
        constraints.gridx = 2;
        constraints.gridy = 2;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill=GridBagConstraints.HORIZONTAL; 
        this.getContentPane().add(miscelania,constraints);
        
        constraints.gridx = 3;
        constraints.gridy = 2;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill=GridBagConstraints.HORIZONTAL;        
        this.getContentPane().add(registroMiscelaneaOps,constraints);
        registroMiscelaneaOps.setSelectedIndex(1);
        registroMiscelaneaOps.addItemListener(this);
       
        JLabel lbdesti = new JLabel("Desti:");
        constraints.gridx = 0;
        constraints.gridy = 3;
        constraints.gridwidth = 1;
        constraints.gridheight = 1; 
        constraints.fill=GridBagConstraints.HORIZONTAL; 
        this.getContentPane().add(lbdesti,constraints);        
         //comboBox registres*** Desti
        constraints.gridx = 0;
        constraints.gridy = 5;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill=GridBagConstraints.HORIZONTAL; 
        this.getContentPane().add(cbregistrosDesti,constraints);
        registroOpsAritmeticas.addItemListener(this); 
        cbregistrosDesti.setSelectedIndex(8);
        
        JLabel lbfont1 = new JLabel("Font1:");
        constraints.gridx = 1;
        constraints.gridy = 3;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill=GridBagConstraints.HORIZONTAL; 
        this.getContentPane().add(lbfont1,constraints);         
        //FONT1
        constraints.gridx = 1;
        constraints.gridy = 5;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill = GridBagConstraints.HORIZONTAL;
        this.getContentPane().add(cbregistrosFont1,constraints);
        registroOpsAritmeticas.addItemListener(this); 
        cbregistrosFont1.setSelectedIndex(8);
        
        JLabel lbfont2 = new JLabel("Font2:");
        constraints.gridx = 2;
        constraints.gridy = 3;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill = GridBagConstraints.HORIZONTAL;
        this.getContentPane().add(lbfont2,constraints);
        //FONT2
        constraints.gridx = 2;
        constraints.gridy = 5;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill = GridBagConstraints.HORIZONTAL;       
        this.getContentPane().add(cbregistrosFont2,constraints);
        cbregistrosFont2.setSelectedIndex(8);
        //registroOps.addItemListener(this);
        
        //OFF-SET
        JLabel lboffset = new JLabel("Offset:");
        constraints.gridx = 0;
        constraints.gridy = 6;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        this.getContentPane().add(lboffset,constraints);
        //cbregistrosMemoria
        offsetInstruccion = new JTextField(10);
        constraints.gridx = 1;
        constraints.gridy = 6;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill = GridBagConstraints.HORIZONTAL; 
        this.getContentPane().add(offsetInstruccion,constraints);
        
        //boton open a program
        constraints.gridx = 1;
        constraints.gridy = 8;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        btnOpen.addActionListener(btnOpenListener);
        this.getContentPane().add(btnOpen,constraints); 
        
        //OFF-SET
       //botton ADD instruction
        constraints.gridx = 2;
        constraints.gridy = 8;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        btnAdd.addActionListener(btnAddListener);
        this.getContentPane().add(btnAdd,constraints);  
        
      //botton ADD instruction
        constraints.gridx = 3;
        constraints.gridy = 8;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        btnSave.addActionListener(btnSaveListener);
        this.getContentPane().add(btnSave,constraints);  
        
        //Program de instrucciones
        areaTexto = new JTextArea ();        
        constraints.gridx = 0; // 
        constraints.gridy = 9; // 
        constraints.gridwidth = 3; // 
        constraints.gridheight = 4; // El rea de texto ocupa 2 filas.
        constraints.weighty = 1.0;
        constraints.weightx = 1.0; 
        constraints.fill = GridBagConstraints.BOTH;
        constraints.insets=new Insets(10,10,60,60);
        this.getContentPane().add (areaTexto, constraints);
          
        setVisible(true);
//        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//        addWindowListener( new WindowAdapter() {
//            public void windowClosing( WindowEvent e ) {
//                System.exit( 0 );
//            }
//        } );
    }
    public class BtnSaveListener implements ActionListener{

		@Override
		public void actionPerformed(ActionEvent e) {
			
			String out="";
			FileOutputStream fout;
			if (e.getSource()==btnSave){
				//abrir un dialogo que rrecoja el nombre del fichero  para escribir el nombre del fichero
				JFrame parentFrame = new JFrame();
				 
				JFileChooser fileChooser = new JFileChooser();
				fileChooser.setDialogTitle("Specify a file to save");   
				BufferedWriter writer = null;
				int userSelection = fileChooser.showSaveDialog(parentFrame);
				
				 
				if (userSelection == JFileChooser.APPROVE_OPTION) {
				    File fileToSave = fileChooser.getSelectedFile();
				    for(int i =0;i<instruccionesSimulador.size();i++){
				    	out = out+instruccionesSimulador.get(i).getOpCode()+" "+instruccionesSimulador.get(i).getDestinoReg()+" "+
				    			instruccionesSimulador.get(i).getFont1Reg()+" "+instruccionesSimulador.get(i).getFont2Reg()+" "+
				    			instruccionesSimulador.get(i).getOffset()+"\n";				    	
				    }
				    try{
			    		writer = new BufferedWriter(new FileWriter(fileToSave.getAbsoluteFile()));
			    		writer.write(out);
			    		writer.close();
			    	}
			    	catch(IOException ex){
			    		JOptionPane.showInputDialog(this);
			    	}
				}
			}
			
		}
    	
    }
    
    public class BtnOpenListener implements ActionListener{

		@Override
		public void actionPerformed(ActionEvent e) {
			String sCadena;
			if (e.getSource()==btnOpen){
				//abrir un dialogo que se pueda introducir el fichero txt
				JFileChooser fileChooser = new JFileChooser();
				int returnValue = fileChooser.showOpenDialog(null);
				//Despues de haber dado a ok 
				try {
					BufferedReader bf = new BufferedReader(new FileReader(fileChooser.getSelectedFile()));
					while((sCadena = bf.readLine())!=null){
						System.out.println(sCadena);
						Instruccion ins = new Instruccion();
						String[] linea = sCadena.split(" ");
						int linealength = linea.length;
						switch (linealength){
							case 0:
								break;
							case 1:
								ins.setOpCode(linea[0]);
								break;
							case 2:
								ins.setOpCode(linea[0]);
								ins.setOffset(linea[1]);
								break;
							case 3:
								//NOT
								ins.setOpCode(linea[0]);
								ins.setDestinoReg(linea[1]);
								ins.setFont1Reg(linea[2]);
								break;
							case 4:
//								if(linea[0].equals("Load"))
								ins.setOpCode(linea[0]);
								ins.setDestinoReg(linea[1]);
								ins.setFont1Reg(linea[2]);
								ins.setFont2Reg(linea[3]);
								break;
							case 5:
								if(linea[0].equals("LOAD")){
									ins.setOpCode(linea[0]);
									ins.setDestinoReg(linea[1]);
									ins.setFont2Reg(linea[3]);
									ins.setOffset(linea[4]);
								}
								else if(linea[0].equals("STORE")){
									ins.setOpCode(linea[0]);
									ins.setFont1Reg(linea[2]);
									ins.setFont2Reg(linea[3]);
									ins.setOffset(linea[4]);
								}
								else if(linea[0].equals("RTR") || linea[0].equals("RTL")){
									ins.setOpCode(linea[0]);
									ins.setDestinoReg(linea[2]);
									ins.setOffset(linea[4]);
								}
								else if(linea[0].equals("JUMP")){
									ins.setOpCode(linea[0]);
									ins.setOffset(linea[4]);
								}
								else if(linea[0].equals("BEQ")||linea[0].equals("BNEQ")||linea[0].equals("BGE")||linea[0].equals("BGOEQ")
										||linea[0].equals("BLE")){
								ins.setOpCode(linea[0]);
								ins.setFont1Reg(linea[2]);
								ins.setFont2Reg(linea[3]);
								ins.setOffset(linea[4]);
							}
								else{
									ins.setOpCode(linea[0]);
									ins.setDestinoReg(linea[1]);
									ins.setFont1Reg(linea[2]);
									ins.setFont2Reg(linea[3]);
									ins.setOffset(linea[4]);
								}
								break;
							default:
								
								break;
						}
						instruccionesSimulador.add(ins);
					}
				} catch (FileNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		}
    	
    }
        
    public class BtnAddListener implements ActionListener{
                                 
    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getSource()==btnAdd) {
        	//comprobar si los datos son al menos correctos.
        	
            //guardamos todos los datos 
            Instruccion instruccion = new Instruccion();
            instruccion.setOpCode(opSeleccionada);
            //operciones de registro
            if(opSeleccionada.equals("AND") || opSeleccionada.equals("OR") || opSeleccionada.equals("XOR") || opSeleccionada.equals("ADD")
            		|| opSeleccionada.equals("SUB") || opSeleccionada.equals("MUL") || opSeleccionada.equals("DIV")){
            	if(cbregistrosDesti.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Desti no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	if(cbregistrosFont1.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Font1 no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	if(cbregistrosFont2.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Font2 no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            }
            
            if(opSeleccionada.equals("ANDI") || opSeleccionada.equals("ORI") || opSeleccionada.equals("XORI") || opSeleccionada.equals("ADDI")
            		|| opSeleccionada.equals("SUBI") || opSeleccionada.equals("MULI") || opSeleccionada.equals("DIVI")){
            	if(cbregistrosDesti.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Desti no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	if(cbregistrosFont1.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Font1 no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	try{
            		boolean valorCorrecto=validaValueMemSeleccionada(offsetInstruccion.getText());
            		if (!valorCorrecto){
            			JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido tiene que ser un entero con signo de 16 bits", "Dialog",JOptionPane.ERROR_MESSAGE);
            			return;
            		}
            	}
	              catch(Exception ex){
	           	   JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido no es correcto", "Dialog",JOptionPane.ERROR_MESSAGE);
	  					return;
	            	}
            	
            }
            
            if(opSeleccionada.equals("NOT") || opSeleccionada.equals("SQR") || opSeleccionada.equals("SQRT") || opSeleccionada.equals("MOV")){
            	if(cbregistrosDesti.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Desti no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	if(cbregistrosFont1.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Font1 no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            }
            
            if(opSeleccionada.equals("RTR") || opSeleccionada.equals("RTL") ){
            	if(cbregistrosFont1.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Font1 no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	try{
            		boolean valorCorrecto=validaValueMemSeleccionada(offsetInstruccion.getText());
            		if (!valorCorrecto){
            			JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido tiene que ser un entero con signo de 16 bits", "Dialog",JOptionPane.ERROR_MESSAGE);
            			return;
            		}
            	}
	              catch(Exception ex){
	           	   JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido no es correcto", "Dialog",JOptionPane.ERROR_MESSAGE);
	  					return;
	            	}
            }
            
            if(opSeleccionada.equals("LImmH") || opSeleccionada.equals("LImmL") ){
            	if(cbregistrosDesti.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Desti no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	try{
            		boolean valorCorrecto=validaValueMemSeleccionada(offsetInstruccion.getText());
            		if (!valorCorrecto){
            			JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido tiene que ser un entero con signo de 16 bits", "Dialog",JOptionPane.ERROR_MESSAGE);
            			return;
            		}
            	}
	              catch(Exception ex){
	           	   JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido no es correcto", "Dialog",JOptionPane.ERROR_MESSAGE);
	  					return;
	            	}
            }
            
            if(opSeleccionada.equals("LOAD")){
            	if(cbregistrosDesti.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Desti no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	//IA
            	try{
            		boolean valorCorrecto=validaValueMemSeleccionada(offsetInstruccion.getText());
            		if (!valorCorrecto){
            			JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido tiene que ser un entero con signo de 16 bits", "Dialog",JOptionPane.ERROR_MESSAGE);
            			return;
            		}
            	}
	              catch(Exception ex){
	           	   JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido no es correcto", "Dialog",JOptionPane.ERROR_MESSAGE);
	  					return;
	            	}
            	if(cbregistrosFont2.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Font2 no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            }
            
            if(opSeleccionada.equals("STORE")){
            	try{
            		boolean valorCorrecto=validaValueMemSeleccionada(offsetInstruccion.getText());
            		if (!valorCorrecto){
            			JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido tiene que ser un entero con signo de 16 bits", "Dialog",JOptionPane.ERROR_MESSAGE);
            			return;
            		}
            	}
	              catch(Exception ex){
	           	   JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido no es correcto", "Dialog",JOptionPane.ERROR_MESSAGE);
	  					return;
	            	}
            	if(cbregistrosFont1.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Font1 no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	if(cbregistrosFont2.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Font2 no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            }
            
            if(opSeleccionada.equals("JUMP")){
            	try{
            		boolean valorCorrecto=validaValueMemSeleccionada(offsetInstruccion.getText());
            		if (!valorCorrecto){
            			JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido tiene que ser un entero con signo de 16 bits", "Dialog",JOptionPane.ERROR_MESSAGE);
            			return;
            		}
            	}
	              catch(Exception ex){
	           	   JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido no es correcto", "Dialog",JOptionPane.ERROR_MESSAGE);
	  					return;
	            	}
            }
            
            if(opSeleccionada.equals("BEQ") || opSeleccionada.equals("BNEQ") || opSeleccionada.equals("BGE") || opSeleccionada.equals("BGOEQ")
            		|| opSeleccionada.equals("BLE")){
            	if(cbregistrosFont1.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Font1 no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	if(cbregistrosFont2.getSelectedItem().equals("")){
            		JOptionPane.showMessageDialog(new JFrame(), "Font2 no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            				return;
            	}
            	try{
            		boolean valorCorrecto=validaValueMemSeleccionada(offsetInstruccion.getText());
            		if (!valorCorrecto){
            			JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido tiene que ser un entero con signo de 16 bits", "Dialog",JOptionPane.ERROR_MESSAGE);
            			return;
            		}
            	}
	              catch(Exception ex){
	           	   JOptionPane.showMessageDialog(new JFrame(), "El formato del parametro introducido no es correcto", "Dialog",JOptionPane.ERROR_MESSAGE);
	  					return;
	            	}
            }
            if(opSeleccionada.equals("")){
     	    	JOptionPane.showMessageDialog(new JFrame(), "Tipo de operacion no puede estar vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
            	return;
            }
            
            
            instruccion.setFont1Reg((String)cbregistrosFont1.getSelectedItem());
            instruccion.setFont2Reg((String)cbregistrosFont2.getSelectedItem());
            instruccion.setDestinoReg((String)cbregistrosDesti.getSelectedItem());
            instruccion.setOffset((String)offsetInstruccion.getText());
            //verificar memoria de dades para guardar todos los datos bien en la instruccion al menos la del offset
//            instruccion.setOffset((String)cbregistrosMemoria.getSelectedItem());
//            instruccion.setOffset((String).getSelectedItem());
            instruccionesSimulador.add(instruccion);
            String txtinstruccion=instruccionesSimulador.size()-1 +".  "+ opSeleccionada+" "+(String)cbregistrosDesti.getSelectedItem()+
                              "  "+(String)cbregistrosFont1.getSelectedItem()+
                              "  "+(String)cbregistrosFont2.getSelectedItem()+
                              "  "+(String)offsetInstruccion.getText()+"\n";
            txtinstruccionbuffer = txtinstruccionbuffer + txtinstruccion;
            areaTexto.setText(txtinstruccionbuffer);
            registroOpsAritmeticas.setSelectedIndex(10);
            logicasOps.setSelectedIndex(7);
            controlOps.setSelectedIndex(6);
            movimientoDesplazamiento.setSelectedIndex(3);
            registroMemoriaOps.setSelectedIndex(4);
            registroMiscelaneaOps.setSelectedIndex(1);
            
            
            registroOpsAritmeticas.setEnabled(true);
            controlOps.setEnabled(true);
            movimientoDesplazamiento.setEnabled(true);
            registroMemoriaOps.setEnabled(true);
            registroMiscelaneaOps.setEnabled(true);
            logicasOps.setEnabled(true);
            
            offsetInstruccion.setText("");;
            cbregistrosDesti.setSelectedIndex(8);
            cbregistrosFont1.setSelectedIndex(8);
            cbregistrosFont2.setSelectedIndex(8);
            
            offsetInstruccion.setEnabled(true);
            cbregistrosDesti.setEnabled(true);
            cbregistrosFont1.setEnabled(true);
            cbregistrosFont2.setEnabled(true);
            setVisible(true);

       }
    }   
    
    }
    //metodo que al obtener OpCode selelccionado lo guarda en OpCode
    @Override
    public void itemStateChanged(ItemEvent e) {
    	
    	cbregistrosDesti.setBackground(Color.WHITE);
    	cbregistrosFont1.setBackground(Color.WHITE);
    	cbregistrosFont2.setBackground(Color.WHITE);
    	offsetInstruccion.setBackground(Color.WHITE);
	    if (e.getSource()==registroOpsAritmeticas ){
	            opSeleccionada=(String)registroOpsAritmeticas.getSelectedItem();
	            registroOpsAritmeticas.setEnabled(true);
	            controlOps.setEnabled(false);
	            movimientoDesplazamiento.setEnabled(false);
	            registroMemoriaOps.setEnabled(false);
	            registroMiscelaneaOps.setEnabled(false);
	            logicasOps.setEnabled(false);
	            if(opSeleccionada.equals("ADD") || opSeleccionada.equals("SUB") || opSeleccionada.equals("MUL")	|| opSeleccionada.equals("DIV")){
	            	offsetInstruccion.setEnabled(false);
	            	
	            }
	            if(opSeleccionada.equals("ADDI") || opSeleccionada.equals("SUBI")
	            	|| opSeleccionada.equals("MULI")
	            	|| opSeleccionada.equals("DIVI")){          	
	            	cbregistrosFont2.setEnabled(false);
	            }
	            if(opSeleccionada.equals("SQR") || opSeleccionada.equals("SQRT")){
	            	offsetInstruccion.setEnabled(false);
	            	cbregistrosFont2.setEnabled(false);
	            }
	    }
	    else if(e.getSource()==logicasOps){
	            opSeleccionada=(String)logicasOps.getSelectedItem();  
	            registroOpsAritmeticas.setEnabled(false);
	            controlOps.setEnabled(false);
	            movimientoDesplazamiento.setEnabled(false);
	            registroMemoriaOps.setEnabled(false);
	            registroMiscelaneaOps.setEnabled(false);
	            logicasOps.setEnabled(true);
	            if(opSeleccionada.equals("AND") || opSeleccionada.equals("OR") || opSeleccionada.equals("XOR")){
	            	offsetInstruccion.setEnabled(false);
	            }
	            if(opSeleccionada.equals("ANDI") || opSeleccionada.equals("ORI") || opSeleccionada.equals("XORI")){
	            	cbregistrosFont2.setEnabled(false);
	            }
	            if(opSeleccionada.equals("NOT")){
	            	offsetInstruccion.setEnabled(false);
	            	cbregistrosFont2.setEnabled(false);
	            }
	    }
	    else if(e.getSource()==movimientoDesplazamiento){
	    	opSeleccionada=(String)movimientoDesplazamiento.getSelectedItem(); 
            registroOpsAritmeticas.setEnabled(false);
            controlOps.setEnabled(false);
            movimientoDesplazamiento.setEnabled(true);
            registroMemoriaOps.setEnabled(false);
            registroMiscelaneaOps.setEnabled(false);
            logicasOps.setEnabled(false);
            if(opSeleccionada.equals("MOV")){
            	cbregistrosFont2.setEnabled(false);
            	offsetInstruccion.setEnabled(false);
            }
            if(opSeleccionada.equals("RTR") || opSeleccionada.equals("RTL")){
            	cbregistrosFont2.setEnabled(false);
            	cbregistrosDesti.setEnabled(false);
            }
	    }
	    else if(e.getSource()==registroMemoriaOps){
	    	opSeleccionada=(String)registroMemoriaOps.getSelectedItem(); 
            registroOpsAritmeticas.setEnabled(false);
            controlOps.setEnabled(false);
            movimientoDesplazamiento.setEnabled(false);
            registroMemoriaOps.setEnabled(true);
            registroMiscelaneaOps.setEnabled(false);
            logicasOps.setEnabled(false);
            if(opSeleccionada.equals("LImmH") || opSeleccionada.equals("LImmL")){
            	cbregistrosFont2.setEnabled(false);
            	cbregistrosFont1.setEnabled(false);
            }
            if(opSeleccionada.equals("LOAD")){
            	cbregistrosFont1.setEnabled(false);
            }
            if(opSeleccionada.equals("STORE")){
            	cbregistrosDesti.setEnabled(false);
            }
	    }
	    else if(e.getSource()==controlOps){
	            opSeleccionada=(String)controlOps.getSelectedItem(); 
	            registroOpsAritmeticas.setEnabled(false);
	            controlOps.setEnabled(true);
	            movimientoDesplazamiento.setEnabled(false);
	            registroMemoriaOps.setEnabled(false);
	            registroMiscelaneaOps.setEnabled(false);
	            logicasOps.setEnabled(false);
	            if(opSeleccionada.equals("JUMP")){
	            	cbregistrosDesti.setEnabled(false);
	            	cbregistrosFont2.setEnabled(false);
	            	cbregistrosFont1.setEnabled(false);
	            }
	            if(opSeleccionada.equals("JUMPI")){
	            	cbregistrosDesti.setEnabled(false);
	            	cbregistrosFont1.setEnabled(false);
	            }
	            if(opSeleccionada.equals("BEQ") || opSeleccionada.equals("BNEQ") || opSeleccionada.equals("BGE") || opSeleccionada.equals("BGOEQ") || opSeleccionada.equals("BLE")){
	            	cbregistrosDesti.setEnabled(false);
	            }
	    }
	    else if(e.getSource()==registroMiscelaneaOps){
	    	opSeleccionada=(String)registroMiscelaneaOps.getSelectedItem(); 
            registroOpsAritmeticas.setEnabled(false);
            controlOps.setEnabled(false);
            movimientoDesplazamiento.setEnabled(false);
            registroMemoriaOps.setEnabled(false);
            registroMiscelaneaOps.setEnabled(true);
            logicasOps.setEnabled(false);
            if(opSeleccionada.equals("NOOP")){
            	offsetInstruccion.setEnabled(false);
            	cbregistrosDesti.setEnabled(false);
            	cbregistrosFont2.setEnabled(false);
            	cbregistrosFont1.setEnabled(false);
            }
    }
	    else{
	        System.out.println("Error:"+e.toString());
	    }

    }   
}   
    
//        
    public class GestorRaton implements MouseListener, MouseMotionListener{
    
        private int x,y;
        private Utils util = null;
    
        public GestorRaton(){
            this.x = 0;
            this.y = 0;
        }
    
        @Override
        public void mousePressed(MouseEvent e) {
            x = e.getX();
            y = e.getY();
        }
        @Override
        public void mouseMoved(MouseEvent e) {
            x = e.getX();
            y = e.getY();
        }
    
        public int getX() {
            return x;
        }   

        public int getY() {
            return y;
        }

        @Override
        public void mouseClicked(MouseEvent mouseClickEvent) {
        
            String instruccionValor = "";
         //write instrucciones   
        if(Utils.comprueba(mouseClickEvent.getX(),botones.get("btnCargarInstrucciones").getPositionX(),
            mouseClickEvent.getY(),botones.get("btnCargarInstrucciones").getPositionY(),
            botones.get("btnCargarInstrucciones").width,botones.get("btnCargarInstrucciones").height))
                    {
                Graphics g = getGraphics();
                cargadorInstrucciones = new CargadorInstrucciones(); 
         }
          //otro boton para cargar en memoria
            else if(Utils.comprueba(mouseClickEvent.getX(),botones.get("btnCargarMemoria").getPositionX(),
            mouseClickEvent.getY(),botones.get("btnCargarMemoria").getPositionY(),
            botones.get("btnCargarMemoria").width,botones.get("btnCargarMemoria").height)){ 
                 
                    Graphics g = getGraphics();
                   cargadorMemoria = new CargadorMemoria();                   
           }
        //boton Tc , ejecuta las operaciones en paralelo
            else if(Utils.comprueba(mouseClickEvent.getX(),botones.get("btnTcP").getPositionX(),
            mouseClickEvent.getY(),botones.get("btnTcP").getPositionY(),
            botones.get("btnTcP").width,botones.get("btnTcP").height)){ 
                 	ejecucion_pipeline();
           }
        
        
            //load instruccions
            else if(Utils.comprueba(mouseClickEvent.getX(),botones.get("btnEjecutarInstruccion").getPositionX(),
            mouseClickEvent.getY(),botones.get("btnEjecutarInstruccion").getPositionY(),
            botones.get("btnEjecutarInstruccion").width,botones.get("btnEjecutarInstruccion").height)){                
                    
            	Graphics g = getGraphics();                                
                    if(instruccionesSimulador.size()>0){
                    	//agregamos los 3 Noops al final para que no haga falta que el usuario tenga que terminar siempre con 3 Noops
                    	Instruccion instruccion = new Instruccion();
                        instruccion.setOpCode("NOOP");
                        for(int i=0;i<3;i++){
                        	instruccionesSimulador.add(instruccion);
                        }
                    	//cargamos el numero de instrucciones
                    	totalInstrucciones = instruccionesSimulador.size();
                        //aqui tenemos todas las instrucciones,al cargar las pintamos todas..
	                    for(int i=0;i<instruccionesSimulador.size();i++){
	                        registres.get("I"+(i)).changeLabel(g, Color.white, Color.black, instruccionesSimulador.get(i).getOpCode()+" "+
	                                instruccionesSimulador.get(i).getDestinoReg()+" "+instruccionesSimulador.get(i).getFont1Reg()+" "
	                                +instruccionesSimulador.get(i).getFont2Reg()+" "
	                                +instruccionesSimulador.get(i).getOffset()); 
	                    }
                    }else
                    {
                        //SI ESTA VACIO EL ARRAY DE INSTRUCCIONES
                    	JOptionPane.showMessageDialog(new JFrame(),"No hay instrucciones a cargar.", "Dialog",JOptionPane.ERROR_MESSAGE);
                    }
            }
        //load instruccions
            else if(Utils.comprueba(mouseClickEvent.getX(),botones.get("btnReset").getPositionX(),
            mouseClickEvent.getY(),botones.get("btnReset").getPositionY(),
            botones.get("btnReset").width,botones.get("btnReset").height)){
            	if(instruccionesSimulador.size()>0){
            		inicializa_cr_memoria();
            		Graphics g=getGraphics();
            		for(int i=1;i<9;i++){
                    	registres.get("CR"+i).changeLabel(g,Color.WHITE, Color.BLACK,"|"+mapaRegistres.get("R"+i));
                    }
            		for(int i=0;i<dadesMemoria.size();i++){
                        registres.get("M"+(dadesMemoria.get(i).getDireccion())).changeLabel(g, Color.white, Color.black,
                        		dadesMemoria.get(i).getValor());
                    }
            		Instruccion i = new Instruccion();
            		i = getInstructionActual(1);
            		registres.get("I"+(iteratorInstrucciones-1)).changeLabel(g, Color.WHITE, Color.BLACK,i.getOpCode()+" "+i.getDestinoReg()+" "+i.getFont1Reg()+" "+i.getFont2Reg()+" "+i.getOffset());
        			iteratorInstrucciones = 0;
        			pcCounter = 0;
        			clean_registers(g);
        			clean_buses(g);
        			buses.get("tcImg").drawFlecha(g,Color.GREEN, Color.GREEN);
//        			ejecucion_pipeline();
            	}
            }
        
            //load dades en memoria
            else if(Utils.comprueba(mouseClickEvent.getX(),botones.get("btnEjecutarDades").getPositionX(),
            mouseClickEvent.getY(),botones.get("btnEjecutarDades").getPositionY(),
            botones.get("btnEjecutarDades").width,botones.get("btnEjecutarDades").height)){                
                    //dadesMemoria
                    Graphics g = getGraphics();  
                    if(dadesMemoria.size()>0){
                        //aqui tenemos todas las dades,al cargar las pintamos todas.. 
                        for(int i=0;i<dadesMemoria.size();i++){
                            registres.get("M"+(dadesMemoria.get(i).getDireccion())).changeLabel(g, Color.white, Color.black,
                            		dadesMemoria.get(i).getValor());
                        }
                    }
                    else{
                        //SI ESTA VACIO EL ARRAY DE INSTRUCCIONES
                        System.out.println("SI ESTA VACIO EL ARRAY DE memoria");
                    }
            }
        
            else {
                        System.out.println("Error:"+mouseClickEvent.toString());
            }
        
    }
    private void ejecucion_pipeline() {
    	 Graphics g = getGraphics();
         try{
         //si no esta vacio la lista de instrucciones ejecutar
                 if(!instruccionesSimulador.isEmpty() && iteratorInstrucciones<=instruccionesSimulador.size() && !instruccionesSimulador.get(iteratorInstrucciones).getOpCode().equals("")){
                 	//si el contador de instrucciones es mayor que cero pinta la instruccion anterior en blanco
                 	if(iteratorInstrucciones>0){
                 		//actualiza la instrucion ejecutada y muestra todas en blanco
                 		update_memoria_programa(g);
                 		//borramos todos los datos de los registro pintados anteriormente
                 		clean_registers(g);
                 		}
	                    switch(pcCounter){                    
			                    case 0:{
			                    	instruccion_fetch_pc0(g);
			                    	break;
			                    }
			                    case 1:{
			                    	instruccion_operands_fetch_pc1(g);
			                    	break;
			                    
			                    }
			                    case 2:{
			                    	instruccion_execute_pc2(g);
			                    	break;
			                    	
			                    }
			                    case 3:{
			                    	instruccion_write_back_pc3(g);
			                    	break;
			                    }                    	
	                    }
	                    
	                    if(pcCounter>3 && (iteratorInstrucciones < instruccionesSimulador.size())){
	                    	
	                    	instruccion_fetch(g);
	                    	instruccion_operands_fetch(g); 
	                    	write_back(g);
	                    	resultado = instruccion_execute(g);
	                    	show_inc_pc(g);
	                    }
	                    incrementa_iterator_pc();
                 }
                 else{
                 	JOptionPane.showMessageDialog(new JFrame(),"Fin del Programa", "Dialog",JOptionPane.ERROR_MESSAGE);
                 }
         }
         catch(IndexOutOfBoundsException ex){
         		JOptionPane.showMessageDialog(new JFrame(),"Fin del programa", "Dialog",JOptionPane.ERROR_MESSAGE);
//				System.exit(0);
         }
			
		}

	private void show_inc_pc(Graphics g) {
    	registres.get("PC").changeLabel(g, Color.RED, Color.BLACK,""+(pcCounter+1));
			
		}

	private void instruccion_write_back_pc3(Graphics g) {
        	write_back(g);
        	resultado = instruccion_execute(g);
        	instruccion_operands_fetch(g);
        	instruccion_fetch(g);
        	registres.get("PC").changeLabel(g, Color.RED, Color.BLACK,""+(pcCounter+1));
			
    }

    private void instruccion_execute_pc2(Graphics g) {
	    	instruccion_operands_fetch(g);
	    	resultado = instruccion_execute(g);		                    	
	    	instruccion_fetch(g);
	    	registres.get("PC").changeLabel(g, Color.RED, Color.BLACK,""+(pcCounter+1));
			
		}

	private void instruccion_operands_fetch_pc1(Graphics g) {
    	instruccion_operands_fetch(g);
    	instruccion_fetch(g);
    	registres.get("PC").changeLabel(g, Color.RED, Color.BLACK,""+(pcCounter+1));
		}

	private void instruccion_fetch_pc0(Graphics g) {
    	instruccion_fetch(g);
    	registres.get("PC").changeLabel(g, Color.RED, Color.BLACK,""+(pcCounter+1));			
		}

	private void update_memoria_programa(Graphics g) {
    	for(int i=0;i<instruccionesSimulador.size();i++){
        	String codigoOperacion = instruccionesSimulador.get(i).getOpCode(); 
        	
	    	String font1=instruccionesSimulador.get(i).getFont1Reg();
	    	String font2=instruccionesSimulador.get(i).getFont2Reg();
	    	String destino=instruccionesSimulador.get(i).getDestinoReg();
	    	String offset=instruccionesSimulador.get(i).getOffset();
	    	String offsetValor =(instruccionesSimulador.get(i).getOffset().equals(null))?" ":instruccionesSimulador.get(i).getOffset();
	    	if(offsetValor.equals("null")){
	    		offsetValor = " ";
	    	}
	    	 //sealamos del el registro de instrucciones que instruccion se esta ejecutando
	    	registres.get("I"+(i)).changeLabel(g, Color.WHITE, Color.BLACK,codigoOperacion+" "+
	    	    	destino+" "+
	    	    	font1+" "+
	    	    	font2+" "+
	    	    	offsetValor);
        	}
		}

	private void clean_registers(Graphics g) {
    	registres.get("IR").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("PC").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("RB").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("RA").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("Offset3").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("Destino3").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("Control4").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("Desti4").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("Offset4").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("Control3").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("DR").changeLabel(g, Color.WHITE, Color.BLACK," ");
    	registres.get("AR").changeLabel(g, Color.WHITE, Color.BLACK," ");
			
		}
	
	private void clean_buses(Graphics g) {
			for(Bus bus : buses.values()){
	            bus.drawFlecha(g, Color.white, Color.red);
	        }
			
		}

	private void write_back(Graphics g) {
    	
    	if(iteratorInstrucciones<instruccionesSimulador.size()){
    		Instruccion instruccion = new Instruccion();
    		instruccion = getInstructionActual(3);
    		actualizaCanvasWB(g,instruccion);
    		}
		}
	
	private Resultado instruccion_execute(Graphics g) {
    	Resultado resultado = new Resultado();
    	
    	if(iteratorInstrucciones<instruccionesSimulador.size() && (instruccionesSimulador.get(iteratorInstrucciones-2)!=null)){
    		Instruccion instruccion = new Instruccion();
    		instruccion = getInstructionActual(2);
		    resultado=actualizaCanvasEX(g,instruccion);		
    	}    
		return resultado;
		}
	private void instruccion_operands_fetch(Graphics g) {
		
		if(iteratorInstrucciones<instruccionesSimulador.size() && instruccionesSimulador.get(iteratorInstrucciones-1)!=null){
					Instruccion instruccion = new Instruccion();
					instruccion = getInstructionActual(1);
					actualizaCanvasOF(g,instruccion);
				}
		}
	
	private void instruccion_fetch(Graphics g) {
		//nunca estara vacio
		if(iteratorInstrucciones<instruccionesSimulador.size())
			{
				Instruccion instruccion = new Instruccion();
				instruccion = getInstructionActual(0);
				actualizaCanvasIF(g,instruccion);
		    	
			}
		}

	private void actualizaCanvasWB(Graphics g, Instruccion instruccion) {
    	registres.get("Control4").changeLabel(g,Color.CYAN, Color.BLACK,instruccion.getOpCode());
    	buses.get("control4DecBus").drawFlecha(g,Color.CYAN, Color.BLACK);
    	//destino3->desti4
    	registres.get("Desti4").changeLabel(g,Color.CYAN, Color.BLACK,instruccion.getDestinoReg());
    	//dec-> -3
    	//offset4 y bus
    	registres.get("Offset4").changeLabel(g,Color.CYAN, Color.BLACK,instruccion.getOffset());
    	buses.get("offset4AluPcCounterBus").drawFlecha(g,Color.CYAN, Color.BLACK);
    	buses.get("aluPcBus").drawFlecha(g, Color.CYAN, Color.CYAN);
    	
    	buses.get("ucMpBus").drawFlecha(g, Color.CYAN, Color.CYAN);
    	buses.get("mdMuxBus").drawFlecha(g,Color.CYAN, Color.BLACK);
		buses.get("MuxCrBus").drawFlecha(g,Color.CYAN, Color.BLACK);
		buses.get("arMdBus").drawFlecha(g,Color.CYAN, Color.BLACK);
			//habilito el bus de deco al flag -3
		//bus pequeo del flag -3 
//		buses.get("offset3Mux2Bus").drawFlecha(g,Color.CYAN, Color.BLACK);
		//del registro dr al mux
		buses.get("DrMuxBus").drawFlecha(g,Color.CYAN, Color.BLACK);
		//obtener del resultado la llave para escribir el valor
			if(!instruccion.getDestinoReg().isEmpty() || !resultado.getLlave().equals("")){
				//guardar con la clave del resultado para saber que donde guardar el valor obtenido en memoria o en registros
				try{
						if(resultado.getLlave().matches("(^)R(.*)")){
							if(instruccion.getOpCode().equals("RTR") || instruccion.getOpCode().equals("RTL")){
								registres.get("C"+resultado.getLlave().substring(0,2)).changeLabel(g,Color.CYAN, Color.BLACK,"|"+resultado.getValor());
							}
							else{
							mapaRegistres.put(resultado.getLlave().substring(0,2),Integer.parseInt(resultado.getValor()));
							registres.get("C"+instruccion.getDestinoReg()).changeLabel(g,Color.CYAN, Color.BLACK,"|"+resultado.getValor());
							}

						}
						else if(resultado.getLlave().matches("(^)M(.*)")){
							try{
							//para las memorias menores que 10 es decir un digito
							Integer llave= Integer.parseInt(resultado.getLlave().substring(1,resultado.getLlave().length()));
							mapaDades.put(""+llave, Integer.parseInt(resultado.getValor()));
							//en memoria
							registres.get("M"+llave).changeLabel(g,Color.CYAN, Color.BLACK,resultado.getValor());
							}catch(Exception ex){
								Integer llave = Integer.parseInt(resultado.getLlave().substring(1,resultado.getLlave().length()));
								JOptionPane.showMessageDialog(new JFrame(),"Memoria : @" + llave + " no existe.", "Dialog",JOptionPane.ERROR_MESSAGE);
//	            				System.exit(0);
							}
		
						}
						else {
							System.out.println("Control op");
						}
				}
				catch(NumberFormatException ex){
					JOptionPane.showMessageDialog(new JFrame(),"Memoria o Registro vacio", "Dialog",JOptionPane.ERROR_MESSAGE);
//    				System.exit(0);
				}
			}
		
	}

	private Resultado actualizaCanvasEX(Graphics g, Instruccion instruccion) {
		registres.get("Control4").changeLabel(g,Color.GREEN, Color.BLACK,instruccion.getOpCode());//pinta el codigoo de operacin que hay de la instruccion anterior
		registres.get("Desti4").changeLabel(g,Color.GREEN, Color.BLACK,instruccion.getDestinoReg());
		registres.get("Offset4").changeLabel(g,Color.GREEN, Color.BLACK,instruccion.getOffset());
		
    	if(instruccion.getOffset()!=null){
    		buses.get("offset3MuxBus").drawFlecha(g,Color.GREEN,Color.BLACK);//si el offset no es nulo pinta los buses 
    		buses.get("raAluBus").drawFlecha(g,Color.GREEN,Color.BLACK);//que van desde el offset(3) hasta el mux
    	}
    	if(!instruccion.getFont2Reg().isEmpty()){
    		buses.get("raAluBus").drawFlecha(g,Color.GREEN,Color.BLACK);
    		buses.get("raDrBus").drawFlecha(g,Color.GREEN,Color.BLACK);
    	}                    	
		//activar el bus del R_B hacia la Alu,no depende de el offset por eso esta fuera del If
	    
	    //status
		//ejecutar la instruccion en la Alu con los parametros y la OPCode
		buses.get("rbAluBus").drawFlecha(g,Color.GREEN,Color.BLACK);
		buses.get("aluPrAdDrBus").drawFlecha(g,Color.GREEN,Color.BLACK);
		buses.get("aluPrAdDr2Bus").drawFlecha(g, Color.GREEN,Color.BLACK);
		buses.get("status4ToAluBus").drawFlecha(g,Color.GREEN,Color.BLACK);
		buses.get("status4DecoBus").drawFlecha(g,Color.GREEN,Color.BLACK);
		buses.get("ctrl3Ctrl4Bus").drawFlecha(g,Color.GREEN, Color.BLACK);
		buses.get("desti3Desti4Bus").drawFlecha(g,Color.GREEN, Color.BLACK);
		////bus pequeo del flag -3 no se toma en cuenta esta seal se deberia pintar solo si la condicion de salto se cumple
		buses.get("offset3Mux2Bus").drawFlecha(g,Color.GREEN, Color.BLACK);
		buses.get("ucFlag3Bus").drawFlecha(g, Color.GREEN, Color.BLACK);
	
	//	resultado=AluUtils.execute(codigoOperacion,destino,font1,font2,offset,mapaRegistres,dadesMemoria,iteratorInstrucciones,pcCounter);
		resultado=AluUtils.execute(instruccion.getOpCode(),instruccion.getDestinoReg(),instruccion.getFont1Reg(),instruccion.getFont2Reg(),instruccion.getOffset(),mapaRegistres,mapaDades,iteratorInstrucciones,pcCounter);
		//mostrar el registro DR con el resultado
		if(resultado.getLlave()!=null && resultado.getValor()!=null){
        	
    		if(resultado.getLlave().matches("(^)R(.*)")){
    			registres.get("DR").changeLabel(g,Color.GREEN,Color.BLACK,resultado.getLlave());
    			
    		}
    		else if(resultado.getLlave().matches("(^)M(.*)")){
				registres.get("AR").changeLabel(g,Color.GREEN,Color.BLACK,"@"+resultado.getLlave().substring(1));
    		}
    		else{
    			registres.get("DR").changeLabel(g,Color.GREEN,Color.BLACK,"");
    			registres.get("AR").changeLabel(g,Color.GREEN,Color.BLACK,"");
    			iteratorInstrucciones = resultado.getIteratorInstrucciones();
    			pcCounter = resultado.getPc();
				System.out.println("El destino esta vacio");
			}
    	        
    	}
    	else{
    		registres.get("DR").changeLabel(g,Color.GREEN,Color.BLACK," ");
    		registres.get("AR").changeLabel(g,Color.GREEN,Color.BLACK," ");
    	}
		return resultado;
	}

	private void actualizaCanvasOF(Graphics g, Instruccion instruccion) {
		buses.get("decCrBus").drawFlecha(g,Color.PINK, Color.BLACK);//dibuja el bus que va desde el decodificador hacia el cr
    	buses.get("decCrDesti3Bus").drawFlecha(g,Color.PINK, Color.BLACK);//dibuja el bus que va desde este hacia el destino
    	
    	buses.get("decCrControl3Bus").drawFlecha(g, Color.PINK, Color.BLACK);//dibuja el bus que va desde este hacia el control
    	//modificacion_vf
    	registres.get("Control3").changeLabel(g,Color.PINK, Color.BLACK,instruccion.getOpCode());//pinta el codigoo de operacin que hay de la instruccion anterior
    	
    	buses.get("ucMdBus").drawFlecha(g,Color.PINK, Color.BLACK);//dibuja el bus que hay entre la Unidad de control hacia la memoria de datos
    		//pinta la fuente1 si hay algo en la fuente1
	    	if(!instruccion.getFont1Reg().isEmpty()){    		
	    		buses.get("crRbBus").drawFlecha(g,Color.PINK,Color.BLACK);
	    		registres.get("RB").changeLabel(g,Color.PINK, Color.BLACK,instruccion.getFont1Reg());
	    	}
	    	else{
	    		buses.get("crRbBus").drawFlecha(g,Color.PINK,Color.BLACK);
	    		registres.get("RB").changeLabel(g,Color.PINK, Color.BLACK," ");
	    	}
	    	//pinta la fuente2 si hay algo en la fuente2
	    	if(!instruccion.getFont2Reg().isEmpty()){
	    		//pintamos el registro R_A con font2 y los buses que corresponden
	    		buses.get("crRaBus").drawFlecha(g,Color.PINK,Color.BLACK);
	    		registres.get("RA").changeLabel(g,Color.PINK, Color.BLACK,instruccion.getFont2Reg());
	    	}//pinta el registro del offset si hay algo
	    	else{
	    		buses.get("crRaBus").drawFlecha(g,Color.PINK,Color.BLACK);
	    		registres.get("RA").changeLabel(g,Color.PINK, Color.BLACK," ");
	    	}
	    	if(!instruccion.getOffset().isEmpty()){
	    		//habilito el registro offset(3) con el offset que obtengo de la instruccion
	    		registres.get("Offset3").changeLabel(g,Color.PINK, Color.BLACK,instruccion.getOffset());
	    		//habilito el bus tambin
	    		buses.get("decCrOffset3Bus").drawFlecha(g,Color.PINK, Color.BLACK);
	    	}
	    	else{
	    		registres.get("Offset3").changeLabel(g,Color.PINK, Color.BLACK," ");
	    		//habilito el bus tambin
	    		buses.get("decCrOffset3Bus").drawFlecha(g,Color.PINK, Color.BLACK);
	    	}
	    	if(!instruccion.getDestinoReg().isEmpty()){
	    		registres.get("Destino3").changeLabel(g,Color.PINK, Color.BLACK,instruccion.getDestinoReg());
	    	}
	    	else{
	    		registres.get("Destino3").changeLabel(g,Color.PINK, Color.BLACK," ");
	    	}
		
	}
	
	private void actualizaCanvasIF(Graphics g, Instruccion instruccion) {
		//actuliza el registro IR y lo pinta en rojo
		registres.get("IR").changeLabel(g, Color.RED, Color.BLACK,
		    	instruccion.getOpCode()+" "+
		    	instruccion.getDestinoReg()+" "+
		    	instruccion.getFont1Reg()+" "+
		    	instruccion.getFont2Reg()+" "+
		    	instruccion.getOffset());
		//pinta la instruccion que se esta ejecutando en amarillo
		registres.get("I"+iteratorInstrucciones).changeLabel(g, Color.YELLOW, Color.BLACK,
				instruccion.getOpCode()+" "+
				instruccion.getDestinoReg()+" "+
				instruccion.getFont1Reg()+" "+
				instruccion.getFont2Reg()+" "+
				instruccion.getOffset());
		//actualiza los buses que corresponden para intruccion IF
		    	buses.get("mpIrBus").drawFlecha(g, Color.RED, Color.BLACK);
		    	buses.get("irDecBus").drawFlecha(g, Color.RED, Color.BLACK);
		    	buses.get("decPcBus").drawFlecha(g, Color.RED, Color.BLACK);
		    	buses.get("aluMpBus").drawFlecha(g, Color.RED, Color.BLACK);
		
	}

	private Instruccion getInstructionActual(int i) {
		Instruccion instruccion = new Instruccion();
		String codigoOperacion = instruccionesSimulador.get(iteratorInstrucciones-i).getOpCode();                    	
    	String opcode = (instruccionesSimulador.get(iteratorInstrucciones-i).getOpCode()!=null)?instruccionesSimulador.get(iteratorInstrucciones-i).getOpCode():" ";
    	String destino = instruccionesSimulador.get(iteratorInstrucciones-i).getDestinoReg();
    	String font1 = instruccionesSimulador.get(iteratorInstrucciones-i).getFont1Reg();
    	String font2 = instruccionesSimulador.get(iteratorInstrucciones-i).getFont2Reg();
    	String offsetValor =(instruccionesSimulador.get(iteratorInstrucciones-i).getOffset().equals(null))?" ":instruccionesSimulador.get(iteratorInstrucciones-i).getOffset();
    	instruccion.setOpCode(opcode);
    	instruccion.setDestinoReg(destino);
    	instruccion.setFont1Reg(font1);
    	instruccion.setFont2Reg(font2);
    	instruccion.setOffset(offsetValor);
		return instruccion;
	}

	@Override
    public void mouseEntered(MouseEvent e) {
    }

    @Override
    public void mouseExited(MouseEvent e) {
    }

    @Override
    public void mouseDragged(MouseEvent e) {
       
    }

    @Override
    public void mouseReleased(MouseEvent e) {
      
    }
}                
            
        public UcController() {
            View view = new View();             
            componentes = view.cargarComponentes();
            buses = view.cargarBuses();
            otrosComp = view.cargarOtrosComp();
            registres = view.cargarRegistres();
            botones = view.cargarBotones();
                     
            mouseEv = new GestorRaton();
           
            //agrego los escuchadores para el raton
            this.addMouseListener(mouseEv);
            this.addMouseMotionListener(mouseEv);
            
            //cargamos toda la memoria con ceros por defecto y tambien los escribimos
            inicializa_cr_memoria();
                    
        }
		public void incrementa_iterator_pc() {
			 iteratorInstrucciones=iteratorInstrucciones+1;
         	pcCounter +=1;
		}
		public void inicializa_cr_memoria(){
			for(int i=0;i<16;i++){
            	Dades dade = new Dades();
            	dade.setDireccion(""+i);              
	            dade.setValor(""+0);  
            	dadesMemoria.add(dade);
            	mapaDades.put(""+i,0);
            }
            for (int i=1;i<9;i++){
            	mapaRegistres.put("R"+i,0);
            }
		}


		@Override
        public void paint( Graphics g ) {
        	
            for(Componente comp : componentes.values()){
                comp.drawComponent(g, Color.lightGray, Color.black);
            }
            for(Registre registre : registres.values()){
                registre.drawRegistre(g, Color.white, Color.black);
            }
           
                       
            ((AluPcCounter)otrosComp.get("aluPcCounter")).drawAluPcCounter(g, Color.lightGray, Color.black);
            ((AluPrincipal)otrosComp.get("aluPrincipal")).drawAluPrincipal(g, Color.lightGray, Color.black);
            ((MultReg)otrosComp.get("multReg")).drawMultReg(g, Color.lightGray, Color.black);
            
                        
            componentes.get("dec").drawComponent(g, Color.lightGray, Color.black);
            
            for(Boton btn : botones.values()){
                btn.drawComponentOval(g, Color.YELLOW, Color.WHITE);
            }       
            for(Bus bus : buses.values()){
                bus.drawFlecha(g, Color.white, Color.red);
            }
            //PINTA ALGUNOS COMPLEMENTOS mas que no tienen ninguna funcion solo de vista
            buses.get("tcImg").drawFlecha(g,Color.GREEN, Color.GREEN);
            registres.get("LoadInstruction").drawRegistreAndMarco(g, Color.YELLOW,Color.black,Color.YELLOW);
            registres.get("WriteInstruction").drawRegistreAndMarco(g, Color.YELLOW,Color.black,Color.YELLOW);
            registres.get("LoadDades").drawRegistreAndMarco(g, Color.YELLOW,Color.black,Color.YELLOW);
            registres.get("WriteDades").drawRegistreAndMarco(g, Color.YELLOW,Color.black,Color.YELLOW);
            registres.get("btnTcP").drawRegistreAndMarco(g, Color.YELLOW,Color.black,Color.YELLOW);
            registres.get("Reset").drawRegistreAndMarco(g, Color.YELLOW,Color.black,Color.YELLOW);
            registres.get("marco").drawRegistreRound(g, Color.YELLOW,Color.black,Color.white);
            registres.get("fetchColor").drawComponentOval(g,Color.RED, Color.WHITE);
            registres.get("operandFetchColor").drawComponentOval(g,Color.PINK, Color.WHITE);
            registres.get("executeColor").drawComponentOval(g,Color.GREEN, Color.WHITE);
            registres.get("writeBackColor").drawComponentOval(g, Color.CYAN, Color.WHITE);
            registres.get("fetchEtiqueta").drawRegistreAndMarco(g, Color.WHITE,Color.black,Color.WHITE);
            registres.get("operandFetchEtiqueta").drawRegistreAndMarco(g, Color.WHITE,Color.black,Color.WHITE);
            registres.get("executeEtiqueta").drawRegistreAndMarco(g, Color.WHITE,Color.black,Color.WHITE);
            registres.get("writeBackEtiqueta").drawRegistreAndMarco(g, Color.WHITE,Color.black,Color.WHITE);
            
            //carga los registros de memoria.
            if(dadesMemoria.size()>0){
                //aqui tenemos todas las dades,al cargar las pintamos todas.. 
                for(int i=0;i<dadesMemoria.size();i++){
                    registres.get("M"+(dadesMemoria.get(i).getDireccion())).changeLabel(g, Color.white, Color.black,
                    		dadesMemoria.get(i).getValor());
                }
            }
            
            for(int i=1;i<9;i++){
            	registres.get("CR"+i).changeLabel(g,Color.WHITE, Color.BLACK,"|"+mapaRegistres.get("R"+i));
            }
            
            
          }
        
        public boolean validaValueMemSeleccionada(String valueMemSeleccionada) {
    		// TODO Auto-generated method stub
    		boolean resultado;
    		Integer value = Integer.parseInt(valueMemSeleccionada);
    		try{
    			value=Integer.parseInt(valueMemSeleccionada.trim());
    			if(value>=-32768 && value<=32767)
    				resultado = true;
    			else 
    				resultado = false;
    		}
    		catch(NumberFormatException ex){
    			resultado = false;
    		}
    		return resultado;
    	}
    
    
}

